## ros-foxy-rclcpp-action 2.4.3

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.5)

project(rclcpp_action)

find_package(ament_cmake_ros REQUIRED)
find_package(action_msgs REQUIRED)
find_package(rclcpp REQUIRED)
find_package(rcl_action REQUIRED)
find_package(rosidl_runtime_c REQUIRED)

# Default to C++14
if(NOT CMAKE_CXX_STANDARD)
  set(CMAKE_CXX_STANDARD 14)
endif()
if(CMAKE_COMPILER_IS_GNUCXX OR CMAKE_CXX_COMPILER_ID MATCHES "Clang")
  add_compile_options(-Wall -Wextra -Wpedantic -Wnon-virtual-dtor -Woverloaded-virtual)
endif()

set(${PROJECT_NAME}_SRCS
  src/client.cpp
  src/qos.cpp
  src/server.cpp
  src/server_goal_handle.cpp
  src/types.cpp
)

add_library(${PROJECT_NAME}
  ${${PROJECT_NAME}_SRCS})

target_include_directories(${PROJECT_NAME}
  PUBLIC
  "$<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/include>"
  "$<INSTALL_INTERFACE:include>")

ament_target_dependencies(${PROJECT_NAME}
  "action_msgs"
  "rcl_action"
  "rclcpp"
  "rosidl_runtime_c"
)

# Causes the visibility macros to use dllexport rather than dllimport,
# which is appropriate when building the dll but not consuming it.
target_compile_definitions(${PROJECT_NAME}
  PRIVATE "RCLCPP_ACTION_BUILDING_LIBRARY")

install(
  DIRECTORY include/
  DESTINATION include)

install(
  TARGETS ${PROJECT_NAME}
  EXPORT ${PROJECT_NAME}
  ARCHIVE DESTINATION lib
  LIBRARY DESTINATION lib
  RUNTIME DESTINATION bin
)

# specific order: dependents before dependencies
ament_export_include_directories(include)
ament_export_libraries(${PROJECT_NAME})
ament_export_targets(${PROJECT_NAME})

ament_export_dependencies(ament_cmake)
ament_export_dependencies(action_msgs)
ament_export_dependencies(rclcpp)
ament_export_dependencies(rcl_action)
ament_export_dependencies(rosidl_runtime_c)

if(BUILD_TESTING)
  find_package(ament_cmake_gtest REQUIRED)
  find_package(ament_lint_auto REQUIRED)
  # Give cppcheck hints about macro definitions coming from outside this package
  set(ament_cmake_cppcheck_ADDITIONAL_INCLUDE_DIRS ${rclcpp_INCLUDE_DIRS})
  ament_lint_auto_find_test_dependencies()

  add_subdirectory(test/benchmark)

  ament_add_gtest(test_client test/test_client.cpp TIMEOUT 180)
  if(TARGET test_client)
    ament_target_dependencies(test_client
      "rcutils"
      "test_msgs"
    )
    target_link_libraries(test_client
      ${PROJECT_NAME}
      mimick
    )
  endif()

  ament_add_gtest(test_server test/test_server.cpp)
  if(TARGET test_server)
    ament_target_dependencies(test_server
      "rcutils"
      "test_msgs"
    )
    target_link_libraries(test_server
      ${PROJECT_NAME}
      mimick
    )
  endif()

  ament_add_gtest(test_server_goal_handle test/test_server_goal_handle.cpp)
  if(TARGET test_server_goal_handle)
    ament_target_dependencies(test_server_goal_handle
      "rcutils"
      "test_msgs"
    )
    target_link_libraries(test_server_goal_handle
      ${PROJECT_NAME}
      mimick
    )
  endif()

  ament_add_gtest(test_traits test/test_traits.cpp)
  if(TARGET test_traits)
    ament_target_dependencies(test_traits
      "test_msgs"
    )
    target_link_libraries(test_traits
      ${PROJECT_NAME}
    )
  endif()

  ament_add_gtest(test_types test/test_types.cpp)
  if(TARGET test_types)
    ament_target_dependencies(test_types
      "test_msgs"
    )
    target_link_libraries(test_types
      ${PROJECT_NAME}
    )
  endif()
endif()

ament_package()

=== test/benchmark/CMakeLists.txt ===
find_package(performance_test_fixture REQUIRED)

# These benchmarks are only being created and run for the default RMW
# implementation. We are looking to test the performance of the ROS 2 code, not
# the underlying middleware.

add_performance_test(
  benchmark_action_client
  benchmark_action_client.cpp
  TIMEOUT 120)
if(TARGET benchmark_action_client)
  target_link_libraries(benchmark_action_client ${PROJECT_NAME})
  ament_target_dependencies(benchmark_action_client rclcpp test_msgs)
endif()

add_performance_test(
  benchmark_action_server
  benchmark_action_server.cpp
  TIMEOUT 120)
if(TARGET benchmark_action_server)
  target_link_libraries(benchmark_action_server ${PROJECT_NAME})
  ament_target_dependencies(benchmark_action_server rclcpp test_msgs)
endif()

=== debian/changelog ===
ros-foxy-rclcpp-action (2.4.3-1focal) focal; urgency=high

  * Revert "Revert "extract the result response before the callback is is… (backport #2152 <https://github.com/ros2/rclcpp/issues/2152>) (#2153 <https://github.com/ros2/rclcpp/issues/2153>)
  * Contributors: Tomoya Fujita

 -- Dirk Thomas <dthomas@osrfoundation.org>  Sat, 27 May 2023 00:00:00 -0000

ros-foxy-rclcpp-action (2.4.2-1focal) focal; urgency=high



 -- Dirk Thomas <dthomas@osrfoundation.org>  Mon, 25 Jul 2022 00:00:00 -0000

ros-foxy-rclcpp-action (2.4.1-1focal) focal; urgency=high

  * Add node_waitables_ to copy constructor (backport #1799 <https://github.com/ros2/rclcpp/issues/1799>) (#1834 <https://github.com/ros2/rclcpp/issues/1834>)
  * Contributors: Abrar Rahman Protyasha, Tomoya Fujita

 -- Dirk Thomas <dthomas@osrfoundation.org>  Mon, 31 Jan 2022 00:00:00 -0000

ros-foxy-rclcpp-action (2.4.0-1focal) focal; urgency=high

  * Fix occasionally missing goal result caused by race condition (#1677 <https://github.com/ros2/rclcpp/issues/1677>) (#1682 <https://github.com/ros2/rclcpp/issues/1682>)
  * Returns CancelResponse::REJECT while goal handle failed to transit to CANCELING state (#1641 <https://github.com/ros2/rclcpp/issues/1641>) (#1659 <https://github.com/ros2/rclcpp/issues/1659>)
  * Fix action server deadlock issue that caused by other mutexes locked in CancelCallback (#1635 <https://github.com/ros2/rclcpp/issues/1635>) (#1654 <https://github.com/ros2/rclcpp/issues/1654>)
  * Contributors: Kaven Yau, Tomoya Fujita

 -- Dirk Thomas <dthomas@osrfoundation.org>  Wed, 01 Sep 2021 00:00:00 -0000

ros-foxy-rclcpp-action (2.3.1-1focal) focal; urgency=high

  * Update quality declaration links (re: ros2/docs.ros2.org#52 <https://github.com/ros2/docs.ros2.org/issues/52>) (#1616 <https://github.com/ros2/rclcpp/issues/1616>)
  * node_handle must be destroyed after client_handle to prevent memory leak (#1562 <https://github.com/ros2/rclcpp/issues/1562>) (#1565 <https://github.com/ros2/rclcpp/issues/1565>)
  * Fix action server deadlock (#1285 <https://github.com/ros2/rclcpp/issues/1285>) (#1313 <https://github.com/ros2/rclcpp/issues/1313>)  (#1518 <https://github.com/ros2/rclcpp/issues/1518>)
  * Contributors: Chris Lalancette, Daisuke Sato, Simon Honigmann, Tomoya Fujita

 -- Dirk Thomas <dthomas@osrfoundation.org>  Wed, 14 Apr 2021 00:00:00 -0000

ros-foxy-rclcpp-action (2.3.0-1focal) focal; urgency=high

  * Update QD to QL 1 (#1480 <https://github.com/ros2/rclcpp/issues/1480>)
  * Add rclcpp_action action_server benchmarks (#1433 <https://github.com/ros2/rclcpp/issues/1433>)
  * Benchmark rclcpp_action action_client (#1429 <https://github.com/ros2/rclcpp/issues/1429>)
  * Increase test timeout necessary for Connext (#1256 <https://github.com/ros2/rclcpp/issues/1256>)
  * Increase coverage rclcpp_action to 95% (#1290 <https://github.com/ros2/rclcpp/issues/1290>)
  * Increase rclcpp_action test coverage (#1153 <https://github.com/ros2/rclcpp/issues/1153>)
  * Contributors: Alejandro Hernández Cordero, Dirk Thomas, Louise Poubel, Michel Hidalgo, Stephen Brawner, ahcorde, brawner

 -- Dirk Thomas <dthomas@osrfoundation.org>  Wed, 09 Dec 2020 00:00:00 -0000

ros-foxy-rclcpp-action (2.2.0-1focal) focal; urgency=high



 -- Dirk Thomas <dthomas@osrfoundation.org>  Wed, 07 Oct 2020 00:00:00 -0000

ros-foxy-rclcpp-action (2.1.0-1focal) focal; urgency=high



 -- Dirk Thomas <dthomas@osrfoundation.org>  Mon, 03 Aug 2020 00:00:00 -0000

ros-foxy-rclcpp-action (2.0.2-1focal) focal; urgency=high



 -- Dirk Thomas <dthomas@osrfoundation.org>  Tue, 07 Jul 2020 00:00:00 -0000

ros-foxy-rclcpp-action (2.0.1-1focal) focal; urgency=high

  * Fixed doxygen warnings (#1163 <https://github.com/ros2/rclcpp/issues/1163>) (#1191 <https://github.com/ros2/rclcpp/issues/1191>)
  * Contributors: Alejandro Hernández Cordero

 -- Dirk Thomas <dthomas@osrfoundation.org>  Tue, 23 Jun 2020 00:00:00 -0000

ros-foxy-rclcpp-action (2.0.0-1focal) focal; urgency=high

  * Added missing virtual destructors. (#1149 <https://github.com/ros2/rclcpp/issues/1149>)
  * Add Security Vulnerability Policy pointing to REP-2006. (#1130 <https://github.com/ros2/rclcpp/issues/1130>)
  * Contributors: Chris Lalancette, Ivan Santiago Paunovic

 -- Dirk Thomas <dthomas@osrfoundation.org>  Mon, 01 Jun 2020 00:00:00 -0000

ros-foxy-rclcpp-action (1.1.0-1focal) focal; urgency=high

  * Action client holds weak pointers to goal handles (#1122 <https://github.com/ros2/rclcpp/issues/1122>)
  * Deprecate ClientGoalHandle::async_result() (#1120 <https://github.com/ros2/rclcpp/issues/1120>)
  * Improve documentation (#1106 <https://github.com/ros2/rclcpp/issues/1106>)
  * Fixed rep links and added more details to dependencies in quality declaration (#1116 <https://github.com/ros2/rclcpp/issues/1116>)
  * Update quality declaration to reflect version 1.0 (#1115 <https://github.com/ros2/rclcpp/issues/1115>)
  * Contributors: Alejandro Hernández Cordero, Jacob Perron, Stephen Brawner

 -- Dirk Thomas <dthomas@osrfoundation.org>  Tue, 26 May 2020 00:00:00 -0000

ros-foxy-rclcpp-action (1.0.0-1focal) focal; urgency=high



 -- Dirk Thomas <dthomas@osrfoundation.org>  Tue, 12 May 2020 00:00:00 -0000

ros-foxy-rclcpp-action (0.9.1-1focal) focal; urgency=high

  * Added Quality declaration: rclcpp, rclpp_action, rclcpp_components andrclcpp_lifecycle (#1100 <https://github.com/ros2/rclcpp/issues/1100>)
  * Contributors: Alejandro Hernández Cordero

 -- Dirk Thomas <dthomas@osrfoundation.org>  Fri, 08 May 2020 00:00:00 -0000

ros-foxy-rclcpp-action (0.9.0-1focal) focal; urgency=high

  * Increasing test coverage of rclcpp_action (#1043 <https://github.com/ros2/rclcpp/issues/1043>)
  * Export targets in addition to include directories / libraries (#1096 <https://github.com/ros2/rclcpp/issues/1096>)
  * Deprecate redundant namespaces (#1083 <https://github.com/ros2/rclcpp/issues/1083>)


=== debian/control ===
Source: ros-foxy-rclcpp-action
Section: misc
Priority: optional
Maintainer: Dirk Thomas <dthomas@osrfoundation.org>
Build-Depends: debhelper (>= 9.0.0), ros-foxy-action-msgs, ros-foxy-ament-cmake, ros-foxy-ament-cmake-gtest <!nocheck>, ros-foxy-ament-cmake-ros, ros-foxy-ament-lint-auto <!nocheck>, ros-foxy-ament-lint-common <!nocheck>, ros-foxy-mimick-vendor <!nocheck>, ros-foxy-performance-test-fixture <!nocheck>, ros-foxy-rcl-action, ros-foxy-rclcpp, ros-foxy-rosidl-runtime-c, ros-foxy-test-msgs <!nocheck>, ros-foxy-ros-workspace
Homepage: 
Standards-Version: 3.9.2

Package: ros-foxy-rclcpp-action
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, ros-foxy-action-msgs, ros-foxy-ament-cmake, ros-foxy-rcl-action, ros-foxy-rclcpp, ros-foxy-rosidl-runtime-c, ros-foxy-ros-workspace
Description: Adds action APIs for C++.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.

# Uncomment this to turn on verbose mode.
export DH_VERBOSE=1
# TODO: remove the LDFLAGS override.  It's here to avoid esoteric problems
# of this sort:
#  https://code.ros.org/trac/ros/ticket/2977
#  https://code.ros.org/trac/ros/ticket/3842
export LDFLAGS=
export PKG_CONFIG_PATH=/opt/ros/foxy/lib/pkgconfig
# Explicitly enable -DNDEBUG, see:
# 	https://github.com/ros-infrastructure/bloom/issues/327
export DEB_CXXFLAGS_MAINT_APPEND=-DNDEBUG
ifneq ($(filter nocheck,$(DEB_BUILD_OPTIONS)),)
	BUILD_TESTING_ARG=-DBUILD_TESTING=OFF
endif

DEB_HOST_GNU_TYPE ?= $(shell dpkg-architecture -qDEB_HOST_GNU_TYPE)

%:
	dh $@ -v --buildsystem=cmake --builddirectory=.obj-$(DEB_HOST_GNU_TYPE)

override_dh_auto_configure:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/foxy/setup.sh" ]; then . "/opt/ros/foxy/setup.sh"; fi && \
	dh_auto_configure -- \
		-DCMAKE_INSTALL_PREFIX="/opt/ros/foxy" \
		-DAMENT_PREFIX_PATH="/opt/ros/foxy" \
		-DCMAKE_PREFIX_PATH="/opt/ros/foxy" \
		$(BUILD_TESTING_ARG)

override_dh_auto_build:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/foxy/setup.sh" ]; then . "/opt/ros/foxy/setup.sh"; fi && \
	dh_auto_build

override_dh_auto_test:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	echo -- Running tests. Even if one of them fails the build is not canceled.
	if [ -f "/opt/ros/foxy/setup.sh" ]; then . "/opt/ros/foxy/setup.sh"; fi && \
	dh_auto_test || true

override_dh_shlibdeps:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/foxy/setup.sh" ]; then . "/opt/ros/foxy/setup.sh"; fi && \
	dh_shlibdeps -l$(CURDIR)/debian/ros-foxy-rclcpp-action//opt/ros/foxy/lib/

override_dh_auto_install:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/foxy/setup.sh" ]; then . "/opt/ros/foxy/setup.sh"; fi && \
	dh_auto_install
